<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file is used for the backend installation and configuration that
 * is accessed via Components->Joomla-SMF Forum->Configuration
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Component
 * @package     com_smf
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: admin.smf.php 231 2006-09-25 22:10:21Z joshualross $
 * @revision    $LastChangedRevision: 231 $
 * @date        $LastChangedDate: 2006-09-25 18:10:21 -0400 (Mon, 25 Sep 2006) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_2_0/admin.smf.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

global $acl, $my, $database;
// ensure user has access to this function
if (!($acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'all' )
        | $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'com_smf' ))) {
    mosRedirect( 'index2.php', _NOT_AUTH );
}

if (!defined('_MOS_ALLOWHTML')) {
    /** #@+
     * Constants
     */
    /**
     * _MOS_ALLOWHTML
     */
    define('_MOS_ALLOWHTML', 0x0002);
    /** #@- */
}

if (!defined('JSMFADMIN_BASE')) {
    /** #@+
     * Constants
     */
    /**
     * JSMFADMIN_BASE
     */
    define('JSMFADMIN_BASE', dirname(__FILE__));
    /** #@- */
}
global $mosConfig_absolute_path;
defined( 'JPATH_BASE' ) or define('JPATH_BASE', $mosConfig_absolute_path);

//$admin_path = $mainframe->getBasePath( 'admin' ).'components/'.$option;
/**
 * Include the associated template file
 */
require_once(JSMFADMIN_BASE.'/admin.smf.html.php');
/**
 * Include Joomla-SMF Admin class
 */
require_once(JSMFADMIN_BASE.'/admin.smf.class.php');
/**
 * Include Joomla-SMF language file
 */
if (file_exists(JSMFADMIN_BASE.'/language/'.$mosConfig_lang.'.php')) {
    include_once(JSMFADMIN_BASE.'/language/'.$mosConfig_lang.'.php');
} else {
    include_once(JSMFADMIN_BASE.'/language/english.php');
}

$jsmfAdmin =& new jsmfAdmin();
$jsmfPatch =& new jsmfPatch();



if (!isset($_SESSION['sync'])) {
    $_SESSION['sync'] = true;
}

//handle the $_REQUEST parameters
$task       = mosGetParam($_REQUEST, 'task', '');
$option     = mosGetParam($_REQUEST, 'option', '');
$mosmsg     = mosGetParam($_REQUEST, 'mosmsg', '');


if (strcmp($task, 'save') == 0) {
    //should be returning an array
    $jsmfConfig = (object) mosGetParam($_REQUEST, 'jsmfConfig', '');
} else {
    //load the parameters
    $jsmfConfig = $jsmfAdmin->loadParams();
}


switch ($task) {

    case "chmod":
        $file = mosGetParam($_REQUEST, 'file', '');
        $mode = mosGetParam($_REQUEST, 'mode', '');
        if (!$jsmfAdmin->chmodFile($file, octdec($mode))) {
            mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED." : "._JSMF_MSG_PLEASE_SET_CHMOD_MANUALLY);
        }
        mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_SUCCESS);
        break;
    case "sync":
        userSync($jsmfAdmin, $jsmfConfig, mosGetParam($_REQUEST, 'type', 'realname'));
        break;
    case "patch":
        //load params
        if (empty($jsmfConfig->url) || empty($jsmfConfig->smf_path)) {
            mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.': '._JSMF_TEXT_INCORRECT_PATH.' '._JSMF_MSG_PLEASE_CLICK_SAVE );

        }

        $search = array(
                    $jsmfPatch->oldMainIndexCode(),
                    $jsmfPatch->oldLoginCode(),
                    $jsmfPatch->oldLogoutCode(),
                    $jsmfPatch->oldMessageCode(),
                    $jsmfPatch->oldHeaderCode()
                    );
        $replace = array(
                    $jsmfPatch->newMainIndexCode(),
                    $jsmfPatch->newLoginCode(),
                    $jsmfPatch->newLogoutCode(),
                    $jsmfPatch->newMessageCode(),
                    $jsmfPatch->newHeaderCode()
                    );
        $code = $jsmfAdmin->patchFile($mosConfig_absolute_path."/index.php", $search, $replace);
        if ($code != JSB_DONE) {
            mosRedirect( "index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$mosConfig_absolute_path."/index.php");
        }
        mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_SUCCESS);
        break;

    case "patchsmf":
        //$jsmfConfig = $jsmfAdmin->loadParams();
        if (empty($jsmfConfig->url) || empty($jsmfConfig->smf_path)) {
            mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.': '._JSMF_TEXT_INCORRECT_PATH.' '._JSMF_MSG_PLEASE_CLICK_SAVE );

        }
        $search = array(
                    $jsmfPatch->oldSMFCodeLine1(),
                    $jsmfPatch->oldSMFCodeLine2()
                    );
        $replace = array(
                    $jsmfPatch->newSMFCodeLine1(),
                    $jsmfPatch->newSMFCodeLine2()
                    );
        $code = $jsmfAdmin->patchFile($jsmfConfig->smf_path."/index.php", $search, $replace);
        if ($code != JSB_DONE) {
            mosRedirect( "index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$jsmfConfig->smf_path."/index.php");
        }
//        $code = $jsmfAdmin->patchFile($jsmfConfig->smf_path."/Sources/Subs-Post.php", array($jsmfPatch->oldSubsPostCodeLine()), array($jsmfPatch->newSubsPostCodeLine()));
//        if ($code != JSB_DONE) {
//            mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$jsmfConfig->smf_path."/Sources/Subs-Post.php");
//        }
//        $code = $jsmfAdmin->patchFile($jsmfConfig->smf_path."/Themes/default/xml_topic.js", array($jsmfPatch->oldSMFQuickReplyCode()), array($jsmfPatch->newSMFQuickReplyCode($mosConfig_live_site.substr($jsmfConfig->smf_path, strlen($mosConfig_absolute_path)))));
//        if ($code != JSB_DONE) {
//            mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$jsmfConfig->smf_path."/Themes/default/xml_topic.js");
//        }
        $code = $jsmfAdmin->patchFile($jsmfConfig->smf_path."/Sources/Subs.php", array($jsmfPatch->oldSMFLoginTimeCode()), array($jsmfPatch->newSMFLoginTimeCode()));
        if ($code != JSB_DONE) {
            mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$jsmfConfig->smf_path."/Sources/Subs.php");
        }
        mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_SUCCESS);
        break;

    case "unpatchsmf":
        //$jsmfConfig = $jsmfAdmin->loadParams();
        //add files to this array to be patched
        $files = array( $jsmfConfig->smf_path."/index.php",
//                        $jsmfConfig->smf_path."/Sources/Subs-Post.php",
//                        $jsmfConfig->smf_path."/Themes/default/xml_topic.js",
                        $jsmfConfig->smf_path."/Sources/Subs.php");
        foreach($files as $file) {
            $code = $jsmfAdmin->unpatchFile($file);
            if ($code != JSB_DONE) {
                mosRedirect( "index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$file);
                break;
        }
        }
        mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_SUCCESS);
        break;

    case "unpatch":
        //$jsmfConfig = $jsmfAdmin->loadParams();
        //add files to this array to be unpatched
        $files = array( $mosConfig_absolute_path."/index.php");
        foreach($files as $file) {
            $code = $jsmfAdmin->unpatchFile($file);
            if ($code != JSB_DONE) {
                mosRedirect( "index2.php?option=$option&amp;task=install", _JSMF_MSG_FAILED.": ".$jsmfAdmin->getErrorMsg($code).$file);
                break;
            }
        }
        mosRedirect("index2.php?option=$option&amp;task=install", _JSMF_MSG_SUCCESS);
        break;
    case "save":
        //make sure the smf path doesn't include our default text
        if (strpos($jsmfConfig->smf_path, _JSMF_TEXT_SMF_PATH_HERE)) {
            $jsmfConfig->smf_path = '';
        }
        if(!$jsmfAdmin->saveParams($jsmfConfig)) {
        	mosRedirect('index2.php?option=com_smf&amp;task='.$jsmfConfig->task, $database->getErrorMsg());
        }
        mosRedirect('index2.php?option=com_smf&amp;task='.$jsmfConfig->task, _JSMF_MSG_SETTINGS_SAVED);
        break;
    case "install":
        installJSMF($jsmfAdmin);
        break;
    case "about":
        displayJSMF($jsmfAdmin);
        break;
    case "error":
        jsmfAdminHTML::showError($mosmsg);
        break;
    case "show":
    case "config":
    case "cancel":
    default:
        configJSMF($jsmfAdmin);
        break;
}


/**
 * Show the install administration
 *
 *
 * @param object reference $jsmfAdmin Joomla-SMF Adminisration functions
 * @return n/a
 */
function installJSMF(&$jsmfAdmin)
{

    $jsmfConfig = $jsmfAdmin->loadParams();

    jsmfAdminHTML::showInstall($jsmfConfig, $jsmfAdmin);
}


/**
 * Show the config administration
 *
 *
 * @param object reference $jsmfAdmin Joomla-SMF Adminisration functions
 * @return n/a
 */
function configJSMF(&$jsmfAdmin)
{

    $jsmfConfig = $jsmfAdmin->loadParams();

    jsmfAdminHTML::showConfig($jsmfConfig, $jsmfAdmin);
}


/**
 * Show the config administration
 *
 *
 * @param object reference $jsmfAdmin Joomla-SMF Adminisration functions
 * @return n/a
 */
function displayJSMF(&$jsmfAdmin)
{

    $jsmfConfig = $jsmfAdmin->loadParams();

    jsmfAdminHTML::showGeneral($jsmfConfig, $jsmfAdmin);
}

/**
 * User synchronization
 *
 *
 * @param object reference $jsmfAdmin Joomla-SMF Adminisration functions
 * @param object reference $jsmfConfig Joomla-SMF configurations
 * @param string $type Synchronization type
 * @return n/a
 */
function userSync(&$jsmfAdmin, &$jsmfConfig, $type)
{
    if ($jsmfAdmin->isUserSync()) {
        $_SESSION['sync'] = true;
        $msg = _JSMF_MSG_SMF_JOOMLA_IN_SYNC;
    } else {
        if (!$_SESSION['sync']) {
            //first, let's determine what type of sync and set that config option
            if (strcmp($type, 'username') == 0) {
                $jsmfConfig->sync_uname = true;
            } else {
                $jsmfConfig->sync_uname = false;
            }
            if (!$jsmfAdmin->saveParams($jsmfConfig)) {
                mosRedirect('index2.php?option=com_smf&amp;task=install', $jsmfAdmin->err);
            }

            //now, go ahead with the sync
            $jcount = 0;
            $scount = 0;
            if (!$jsmfAdmin->syncUsers($jcount, $scount)) {
                //some sort of error occurred
                $msg = "Joomla/Mambo[".$jcount."] / SMF[".$scount."] " . _JSMF_MSG_INSERTED ." <br /> " . _JSMF_MSG_FAILED." :$jsmfAdmin->err";
                //mosRedirect( "index2.php?option=$option&amp;task=error", "Joomla/Mambo[".$jcount."] / SMF[".$scount."] " . _JSMF_MSG_INSERTED ." <br /> " . _JSMF_MSG_FAILED." :$error");
            } else {
                $_SESSION['sync'] = true;
                $msg = "Joomla/Mambo[".$jcount."] / SMF[".$scount."] " . _JSMF_MSG_INSERTED;
                //mosRedirect( "index2.php?option=$option&amp;task=install", "Joomla/Mambo[".$jcount."] / SMF[".$scount."] " . _JSMF_MSG_INSERTED
            }
        } else {
            $_SESSION['sync'] = false;
        }
    }
    mosRedirect("index2.php?option=com_smf&amp;task=install", $msg);
}

?>