
<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file generates a link from a content item to a SMF board based on
 * either a default of a parameter passed from the triggering code.
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Mambot
 * @package     mos_smf_discussbot
 * @author      Jick <jick@jigsnet.com>
 * @author      Theodore Hildebrandt
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) 2006 Theodore Hildebrandt
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: mos_smf_discussbot.php 53 2006-11-01 02:49:52Z joshualross $
 * @revision    $LastChangedRevision: 53 $
 * @date        $LastChangedDate: 2006-11-01 02:49:52Z $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_discussbot/mos_smf_discussbot.php $
 * @link        http://www.JoomlaHacks.com
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */

defined( '_VALID_MOS' ) or die( 'Restricted Access' );
//Let's get registered
$_MAMBOTS->registerFunction( 'onPrepareContent', 'MOSBOT_add_smfforumlink' );

//If we aren't on the frontpage or content page  then return
if ( strcasecmp($_REQUEST['option'], "com_content") != 0 && strcasecmp($_REQUEST['option'], "com_frontpage") != 0 ) {
     return;
}



function MOSBOT_add_smfforumlink( &$published, &$row ) {
    //If we aren't published return
    if ( !$published ) {
        return;
    }
    global $database, $mainframe, $mosConfig_absolute_path;

    //globalize the parameters
    global $num_chars, $discuss_image, $quote_images, $begin_end, $default_discuss;
    global $title_prefix, $link_text, $linkback_prefix, $category_prefix, $instant;
    global $joscatsec, $days, $auto_reply, $auto_reply_img;


     // load mambot params info
    $query =
        "SELECT id " .
        "FROM #__mambots " .
        "WHERE element = 'mos_smf_discussbot' " .
        "AND folder = 'content'";

    $database->setQuery( $query );
    $id                = $database->loadResult();
    $mambot            = new mosMambot( $database );
    $mambot->load( $id );
    $botParams         = new mosParameters($mambot->params);
    $num_chars         = $botParams->get( 'num_chars', '' );
    $discuss_image     = $botParams->get( 'discuss_image', '/mambots/content/mos_smf_discussbot.gif' );
    $quote_images      = $botParams->get( 'quote_images', 1 );
    $begin_end         = $botParams->get( 'begin_end', 0 );
    $default_discuss   = $botParams->get( 'default_discuss', '' );
    $title_prefix      = $botParams->get( 'title_prefix', '' );
    $category_prefix   = $botParams->get( 'category_prefix', '' );
    $linkback_prefix   = $botParams->get( 'linkback_prefix', '' );
    $link_text         = $botParams->get( 'link_text', '' );
    $auto_reply        = $botParams->get( 'auto_reply', '0' );
    $auto_reply_img    = $botParams->get( 'auto_reply_img', '1' );
    $discuss_all       = $botParams->get( 'discuss_all', '0' );
    $instant           = $botParams->get( 'instant_discuss', '0' );
    $days              = $botParams->get( 'days', '30' );
    $joscatsec         = $botParams->get( 'jos_prefix', '0' );

    //Check to make sure we aren't in the newsflash box!
    if (!empty($row->catid)) {
        /*1.2 add link for discussion of all content (JohnP of joomlhacks.com)*/
        if ($discuss_all) {
            //if we don't find the code add it
            if (strpos($row->text,"{mos_smf_discuss") == 0)
            $row->text .= "{mos_smf_discuss}";
        }

         //let's start by verifying if this content is attempting to use the discussbot
         if (preg_match("/{mos_smf_discuss/", $row->text)) {

              //If they are trying to use the default board make sure it is set or error!
              //1.4.2 If instant and default discuss isn't set then display and error
              if (empty($default_discuss) && (strpos($row->text,"{mos_smf_discuss}") || $instant)) {
                   $row->text = str_replace("{mos_smf_discuss}","<b>{mos_smf_discuss:undefined default board}</b>",$row->text);
                   return;
              } else {
                   //find all instances requiring default board and replace with default discuss variable
                   $row->text = str_replace("{mos_smf_discuss}","{mos_smf_discuss:$default_discuss}",$row->text);
              }

              //let's make a copy for safety
              $mos_smf_discuss_entrytext = $row->text;
              $mos_smf_discuss_matches = array();
              if (preg_match_all("/{mos_smf_discuss:.+?}/", $mos_smf_discuss_entrytext, $mos_smf_discuss_matches, PREG_PATTERN_ORDER) > 0) {
                   foreach ($mos_smf_discuss_matches[0] as $mos_smf_discuss_match) {
                        $showbottext = "";
                        $mos_smf_discuss_match = str_replace("{mos_smf_discuss:", "", $mos_smf_discuss_match);
                        $mos_smf_discuss_match = str_replace("}", "", $mos_smf_discuss_match);
                        if (strcasecmp($mos_smf_discuss_match, "no_discuss") == 0) {
                             $showbottext = "";
                        } else {
                             $showbottext = make_smfforumlink( $mos_smf_discuss_match, $row);
                        }
                        $mos_smf_discuss_entrytext = str_replace("{mos_smf_discuss:".$mos_smf_discuss_match."}", $showbottext, $mos_smf_discuss_entrytext);
                   }
                   $row->text = $mos_smf_discuss_entrytext;
              }
              //free a little memory
              unset($mos_smf_discuss_entrytext);
         } else {
              //not using discussbot
              return;
         }
    }
}

function make_smfforumlink($catid, &$row){
    global $database, $mainframe, $mosConfig_live_site;
    global $settings, $boardurl;
    global $num_chars, $discuss_image, $quote_images, $begin_end, $default_discuss, $title_prefix, $link_text;
    global $linkback_prefix, $category_prefix, $instant, $track, $joscatsec, $days, $auto_reply, $auto_reply_img;
    //global $user_info, $board_info;


    //2.0 first, get the class object, then use it to load the params
    $jsmf =& jsmfFrontend::singleton();
    $jsmfConfig = $jsmf->loadParams();

    //let's check if the board exists first
    //Don't worry if the board doesn't exist, SMF will handle the error reporting
    $query =
        "SELECT ID_BOARD " .
        "FROM {$jsmfConfig->smf_prefix}boards " .
        "WHERE name='".$catid."';";
    $database->setQuery($query);
    $boardid = $database->loadResult();


    //replace apostrophes?  why not escape them?
    $title = rtrim(str_replace("'","`",$row->title));

    //Add the Joomla Section/Category
    $sectionid = $row->sectionid;
    $categoryid = $row->catid;
    $jcs = '';
    if ($joscatsec == '2') {
        $query =
            "SELECT TITLE " .
            "FROM #__sections " .
            "WHERE id='".$sectionid."';";
        $database->setQuery($query);
        $jcs = rtrim(str_replace("'", "`", $database->loadResult()));
     } else if ($joscatsec == '1') {
        $query =
            "SELECT TITLE " .
            "FROM #__categories " .
            "WHERE id='".$categoryid."';";
        $database->setQuery($query);
        $jcs = rtrim(str_replace("'", "`", $database->loadResult()));
     }
     if (!empty($jcs)) {
        $jcs = "[".$jcs."] ";
     }


     //Add the title prefix
     //stripping trailing spaces and add a colon followed by a space
     if (!empty($title_prefix)) {
        $title_prefix = rtrim($title_prefix).": ";
    }

    //now, if the topic title includes the SMF category of the board, let's retrieve the name and add it
    // to make sure that no 0 are added at the beginning of the title - (Montty - elemency.com)
    //1.3 SMF category title prefix(-Wolverine)
    $cat_prefix = '';
    if ($category_prefix) {
        $query =
            "SELECT sc.name " .
            "FROM {$jsmfConfig->smf_prefix}categories AS sc " .
            "LEFT JOIN {$jsmfConfig->smf_prefix}boards AS sb ON (sb.ID_CAT = sc.ID_CAT) " .
            "WHERE sb.ID_BOARD='".$boardid."';";
        $database->setQuery($query);
        $cat_prefix = $database->loadResult();
        if (!empty($cat_prefix)) {
            $cat_prefix = "[".trim($category_prefix)."] ";
        } 
    }


    //build the title
    $topic_title = $jcs.$cat_prefix.$title_prefix.$title;

    //Create the linkback title
    if (!empty($linkback_prefix)) {
        $linkback_prefix = rtrim($linkback_prefix).": ";
    }
    $linkback_title = $linkback_prefix.$title;


    //format the parameter days into seconds for comparison
    $seconds = $days*24*60*60;

    //format the created time into something we can compare with time()
    //content time is:  YYYY-MM-DD HH:MM:SS
    //if the article was recently modified, then use modified time rather
    //than created time
    if (strtotime($row->created) < strtotime($row->modified)) {
        $ctime = strtotime($row->modified);
    } else {
        $ctime = strtotime($row->created);
    }


    // Check if the subject as content title exists in the messages table
    $query =
        "SELECT ID_TOPIC " .
        "FROM {$jsmfConfig->smf_prefix}messages " .
        "WHERE ID_BOARD = '".$boardid."' " .
        "AND subject = '".$topic_title."';";
    $database->setQuery($query);
    $resultid = $database->loadResult();

    // Is there already a topic for this?  If not, make a new topic
    if (empty($resultid)) {
        $message = trim($row->text);

        if (!$instant || !((time()-$seconds) < $ctime)) {
            //if numchars is 0, don't quote the post, if
            if (strcasecmp($num_chars, '0') !=  0) {
                //if num_chars is not 0 and empty, include the full post
                if (empty($num_chars)) {
                    $message = '[quote]'.$message.'[/quote]';
                } else {
                	$message = '[quote]'.substr($message,0,$num_chars).'. . .[/quote]';
                }
            } else {
            	$message = '';
            }
        }



        //build the message url
        //old method -> $message = "[url=".sefRelToAbs("index.php?".($_REQUEST['option'] == "com_content" && isset($_REQUEST, ['task'] && $_REQUEST['task'] == "view" ? $_SERVER['QUERY_STRING'] : "option=com_content&amp;task=view&amp;id=".$row->id."&amp;Itemid=".$mainframe->getItemid( $row->id, 0, 0 )))."]".$linkback_title."[/url]\n".$message;
        $url = '';
        $option = mosGetParam($_REQUEST, 'option', '');
        $task = mosGetParam($_REQUEST, 'task', '');
        if (strcasecmp($option, 'com_content') == 0 && strcasecmp($task, 'view') == 0) {
        	$url = mosGetParam($_SERVER, 'QUERY_STRING', null);
        } else {
        	$url = 'index.php?option=com_content&amp;task=view&amp;id='.$row->id.'&amp;Itemid='.$mainframe->getItemid($row->id, 0, 0);
        }
        $message = "[url=".sefRelToAbs($url)."]".$linkback_title."[/url]\n".$message;


        $search = array("/\</",
                        "/\>/",
                        "/\\\"/",
                        "/\[p([^\]]*)\]{1}/i",
                        "/\[\/p\]/i",
                        "/\[\!--.*--\]/i",
                        "/\[font([^\]]*)\]{1}/i",
                        "/\[\/font\]/i",
                        "/\[img.*src\=http/i",
                        "/\[img.*src\=/i",
                        "/jpg([^\]]*)\]{1}/i",
                        "/gif([^\]]*)\]{1}/i",
                        "/png([^\]]*)\]{1}/i",
                        "/jpeg([^\]]*)\]{1}/i",
                        "/\[a.+?(href=\"?http){1}/i",
                        "/\[a.+?(href=\"?){1}/i",
                        "/target\=([^\]]*)\]{1}/i",
                        "/title\=([^\]]*)\]{1}/i",
                        "/\[\/a\]/i",
                        "/\[table([^\]]*)\]{1}/i",
                        "/\[tbody\]/i",
                        "/\[\/tbody\]/i",
                        "/\[td([^\]]*)\]{1}/i",
                        "/\[strike\]/i",
                        "/\[\/strike\]/i",
                        "/\[em\]/i",
                        "/\[\/em\]/i",
                        "/\[strong\]/i",
                        "/\[\/strong\]/i",
                        "/\[ol\]/i",
                        "/\[\/ol\]/i",
                        "/\[ul\]/i",
                        "/\[\/ul\]/i",
                        "/\[div.*\]/i",
                        "/\[\/div\]/i",
                        "/\[span([^\]]*)\]{1}/i",
                        "/\[\/span\]/i",
                        "/\[h1]/i",
                        "/\[h2]/i",
                        "/\[h3]/i",
                        "/\[h4]/i",
                        "/\[h5]/i",
                        "/\[h6]/i",
                        "/\[\/h.?]/i",
                        "/{mos_smf_discuss:.+?}/i");
        if ($quote_images) {
            $replace = array("[",
                             "]",
                             "",
                             "",
                             "\n",
                             "",
                             "",
                             "",
                             "[img]http",
                             "[img]".$mosConfig_live_site."/",
                             "jpg[/img]\n",
                             "gif[/img]\n",
                             "png[/img]\n",
                             "jpeg[/img]\n",
                             "[url=http",
                             "[url=".$mosConfig_live_site."/",
                             "]",
                             "]",
                             "[/url]",
                             "[table]",
                             "",
                             "",
                             "[td]",
                             "[s]",
                             "[/s]",
                             "[i]",
                             "[/i]",
                             "[b]",
                             "[/b]",
                             "[list]",
                             "[/list]",
                             "[list]",
                             "[/list]",
                             "",
                             "",
                             "",
                             "",
                             "[b][size=6]",
                             "[b][size=5]",
                             "[b][size=4]",
                             "[b][size=3]",
                             "[b][size=2]",
                             "[b][size=1]",
                             "[/size][/b]",
                             "");
        } else {
            $replace = array("[",
                             "]",
                             "",
                             "",
                             "\n",
                             "",
                             "",
                             "",
                             "",
                             "",
                             "",
                             "",
                             "",
                             "",
                             "[url=http",
                             "[url=".$mosConfig_live_site."/",
                             "]",
                             "]",
                             "[/url]",
                             "[table]",
                             "",
                             "",
                             "[td]",
                             "[s]",
                             "[/s]",
                             "[i]",
                             "[/i]",
                             "[b]",
                             "[/b]",
                             "[list]",
                             "[/list]",
                             "[list]",
                             "[/list]",
                             "",
                             "",
                             "",
                             "",
                             "[b][size=6]",
                             "[b][size=5]",
                             "[b][size=4]",
                             "[b][size=3]",
                             "[b][size=2]",
                             "[b][size=1]",
                             "[/size][/b]",
                             "");
        }
        $message = preg_replace($search, $replace, $message);



        if ($instant && ((time()-$seconds) < $ctime)) {
            //Get the Subs-Post.php file to run the createPost function
            include_once($jsmfConfig->smf_path . '/Sources/Subs-Post.php');

            //Remove all HTML entities from the code
            $message = html_entity_decode($message, ENT_QUOTES);
            //Replace ALL single and double quotes, amersands, and more with HTML markup
            //Should be cross PHP (4/5)
            $message = htmlspecialchars($message, ENT_QUOTES);

            //Call the authors Joomla! User ID
//
//			$mid = $row->id;
//            $query =
//                "SELECT created_by " .
//                "FROM #__content " .
//                "WHERE ID = '{$mid}';";
//            $database->setQuery($query);
//            $uid = $database->loadResult();



            //Get the username associated with the User ID and return
            $query =
                "SELECT username " .
                "FROM #__users " .
                "WHERE ID = '{$row->created_by}';";
            $database->setQuery($query);
            $username = $database->loadResult();
            //uname

            //Get the user with the same Username in the SMF user table
            $query =
                "SELECT ID_MEMBER " .
                "FROM {$jsmfConfig->smf_prefix}members " .
                "WHERE memberName = '{$username}';";
            $database->setQuery($query);
            $smf_id = $database->loadResult();
            //finalid


            //Builds the message
            $msgOptions = array(
                'id' => empty($_REQUEST['msg']) ? 0 : (int) $_REQUEST['msg'],
                'subject' => $topic_title,
                'body' => $message,
                'icon' => 'xx',
                'smileys_enabled' => !isset($_POST['ns']),
                'attachments' => empty($attachIDs) ? array() : $attachIDs,
            );

            //Builds a forum topic
            $topicOptions = array(
                'id' => empty($topic) ? 0 : $topic,
                'board' => $boardid,
                'poll' => null,
                'lock_mode' => isset($_POST['lock']) ? (int) $_POST['lock'] : null,
                'sticky_mode' => isset($_POST['sticky']) && !empty($modSettings['enableStickyTopics']) ? (int) $_POST['sticky'] : null,
                'mark_as_read' => true,
            );

            //Who's doing the posting?
            $posterOptions = array(
                'id' => $smf_id,
                'name' => isset($_POST['guestname']),
                'email' => isset($_POST['email']),
                'update_post_count' => true,
            );

            //Creates the post. Requires subs-post.php
            createPost($msgOptions, $topicOptions, $posterOptions);


            $query =
                "SELECT ID_FIRST_MSG, ID_LAST_MSG, numReplies " .
                "FROM {$jsmfConfig->smf_prefix}topics " .
                "WHERE ID_TOPIC = '".$topicOptions['id']."';";
            $database->setQuery($query);
            $topic = null;
            $database->loadObject($topic);


            if ($begin_end) {
                $smf_location = ".msg".$topic->ID_FIRST_MSG."#msg".$topic->ID_FIRST_MSG;
            } else {
                $smf_location = ".msg".$topic->ID_LAST_MSG."#msg".$topic->ID_LAST_MSG;
            }

            //Post the reply button
            if ($auto_reply) {
                if ($auto_reply_img) {
                    $showlink = '<a class="link_pos" href="'. $jsmf->fixLink('index.php?action=post;topic='. $topicOptions['id'] . ';num_replies=' . $topic->numReplies) . '"><img border="0" src="' . $settings['images_url'] . '/topic/my_veryhot_post.gif" alt="Reply to Topic" /> ('.$topic->numReplies.') '.$link_text.'</a>';
                } else {
                    $showlink = '<a class="link_pos" href="'. $jsmf->fixLink('index.php?action=post;topic='. $topicOptions['id'] . ';num_replies=' . $topic->numReplies) . '"><img style="border:0px;" src="'.$discuss_image.'" alt="Discuss Topic" /> ('.$topic->numReplies.') '.$link_text.'</a>';
                }
            } else {
                $showlink = '<a class="link_pos" href="' . $jsmf->fixLink('index.php?topic=' . $topicOptions['id'] . $smf_location) . '"><img style="border:0px;" src="'.$discuss_image.'" alt="Discuss Topic" /> ('.$topic->numReplies.') '.$link_text.'</a>';
            }


            //return $showlink;
        } else {
            //Autopost isn't on... time to do this
            echo '<form id="a'.$row->id.'" action="'.$jsmf->fixLink().'" method="post">';
            echo '<fieldset style="border:0px;">';
            echo '<input type="hidden" name="board" value="'.$boardid.'" />';
            echo '<input type="hidden" name="icon" value="xx" />';
            echo '<input type="hidden" name="action" value="post" />';
            echo '<input type="hidden" name="subject" value="'.$topic_title.'" />';
            echo '<input type="hidden" name="message" value="'.$message.'" />';
            echo '<input type="hidden" name="option" value="'.$jsmfConfig->option.'" />';
            echo '<input type="hidden" name="goback" value="true" />';
            echo '</fieldset>';
            echo '</form>';
            $showlink = '<a class="link_pos" style="cursor:pointer;" onclick="javascript:send_form('.$row->id.')"><img style="border:0px;" src="'.$discuss_image.'" alt="Discuss Topic" /> (0) '.$link_text.'</a>';
        }

    } else {
        // There must already be a topic, so let's make a link to reply
        $query =
            "SELECT ID_FIRST_MSG, ID_LAST_MSG, numReplies " .
            "FROM {$jsmfConfig->smf_prefix}topics " .
            "WHERE ID_TOPIC = '".$resultid."';";
        $database->setQuery($query);
        $topic = null;
        $database->loadObject($topic);

//        if (!$instant || !((time()-$seconds) < $ctime)) {
//            $replies = $topic->numReplies + 1;
//        } else {
//            $replies = $topic->numReplies;
//        }
        if ($begin_end) {
            $smf_location = ".msg$topic->ID_FIRST_MSG#msg$topic->ID_FIRST_MSG";
        } else {
            $smf_location = ".msg$topic->ID_LAST_MSG#msg$topic->ID_LAST_MSG";
        }


        if ($auto_reply) {
            if ($auto_reply_img) {
                $showlink = '<div class="dsc_bar"><a class="link_pos" href="'.$jsmf->fixLink('index.php?action=post;topic=' . $resultid . ';num_replies=' . $topic->numReplies) . '"><img border="0" src="' . $settings['images_url'] . '/topic/my_veryhot_post.gif" alt="Reply to Topic" /> ('.$topic->numReplies.') '.$link_text.'</a></div>';
            } else {
            	$showlink = '<div class="dsc_bar"><a class="link_pos" href="'.$jsmf->fixLink('index.php?action=post;topic=' . $resultid . ';num_replies=' . $topic->numReplies) . '"><img style="border:0px;" src="'.$discuss_image.'" alt="Discuss Topic" /> ('.$topic->numReplies.') '.$link_text.'</a></div>';
            }
        } else {
            $showlink = '<div class="dsc_bar"><a class="link_pos" href="'.$jsmf->fixLink('index.php?topic=' . $resultid . $smf_location) . '"><img style="border:0px;" src="'.$discuss_image.'" alt="Discuss Topic" /> ('.$topic->numReplies.') '.$link_text.'</a></div>';
        }
    }
    return $showlink;
} //end of make_smfforumlink

?>


<?php
global $mainframe, $mosConfig_live_site, $discuss_image;
$mainframe->addCustomHeadTag("
<script type='text/javascript'>
function send_form(form_id) {
    document.getElementById('a'+form_id).submit();
}
</script>
<style type=\"text/css\">
hr{margin-top:5px;clear:both;}
.link_pos{float:right; background-color:transparent;}
.sub_bttn{padding-left:0px;padding-right:0px;padding-bottom:0px;padding-top:0px;border-width:0px;width:120px;height:18px;float:right;background-image:url('".$mosConfig_live_site.$discuss_image."');background-color:#000000;}
.dsc_bar{clear:both; display:block;};
</style>")?>