<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Community Builder plugin
 *
 * This file is the plugin for Community Builder
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Plugin
 * @package     smf_cb_plug
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: smf_cb.php 48 2006-10-27 01:11:41Z joshualross $
 * @revision    $LastChangedRevision: 48 $
 * @date        $LastChangedDate: 2006-10-27 01:11:41Z $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_cb_plugin/smf_cb.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */


// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Restricted access.' );

global $mosConfig_absolute_path, $mosConfig_lang;
defined( 'JPATH_BASE' ) or define('JPATH_BASE', $mosConfig_absolute_path);
defined('_MOS_ALLOWHTML') or define('_MOS_ALLOWHTML', 0x0002);
/**
 * Include Joomla-SMF Frontend class and language class
 */
require_once(JPATH_BASE.'/components/com_smf/smf.class.php');
if (file_exists(JPATH_BASE.'/administrator/components/com_smf/language/'.$mosConfig_lang.'.php')) {
    require_once(JPATH_BASE.'/administrator/components/com_smf/language/'.$mosConfig_lang.'.php');
} else {
    require_once(JPATH_BASE.'/administrator/components/com_smf/language/english.php');
}


//register our functions
$_PLUGINS->registerFunction( 'onAfterLogin', 'login', 'jsmfCB');
$_PLUGINS->registerFunction( 'onLogout', 'logout', 'jsmfCB');  //backwards compatiblity for 1.0RC2
$_PLUGINS->registerFunction( 'onBeforeLogout', 'logout', 'jsmfCB');
$_PLUGINS->registerFunction( 'onUserActive', 'activateUser', 'jsmfCB');
$_PLUGINS->registerFunction( 'onBeforeUserRegistration', 'validateUser', 'jsmfCB');  //validate not in SMF already
$_PLUGINS->registerFunction( 'onAfterUserRegistration', 'registerUser', 'jsmfCB');
$_PLUGINS->registerFunction( 'onBeforeNewUser', 'validateUser', 'jsmfCB');  //validate user not in SMF already
$_PLUGINS->registerFunction( 'onAfterNewUser', 'registerUser', 'jsmfCB');

$_PLUGINS->registerFunction( 'onBeforeDeleteUser', 'deleteUser', 'jsmfCB');

//$_PLUGINS->trigger( 'onNewPassword', array($user_id,$newpass));

$_PLUGINS->registerFunction( 'onNewPassword', 'updatePass', 'jsmfCB' );
//updates
//onBeforeUserUpdate - &$row,&$rowExtras
//TODO onBeforeUserUpdate  make sure there are no conflicts before updating
//onAfterUserUpdate - $row, $rowExtras, true
$_PLUGINS->registerFunction( 'onBeforeUserUpdate', 'updateUser', 'jsmfCB');
//$_PLUGINS->registerFunction( 'onAfterUserUpdate', 'updateUser', 'jsmfCB');

//TODO avatar selection from gallery once it is implemented in CB
//for these, if there is a file, save it to the SMF avatar dir and return a link and update $row->avatar
//onBeforeUserAvatarUpdate - &$row,&$rowExtras,$isModerator,&$_FILES['avatar']['tmp_name']
$_PLUGINS->registerFunction( 'onAfterUserAvatarUpdate', 'updateAvatar', 'jsmfCB');
//onAfterUserAvatarUpdate - &$row,&$rowExtras,$isModerator,$newFileName  <--pass by reference is mute point, the vars are not updated

//Administration:  these should be the easy ones as the admin interface only has the default fields
//  onBeforeUpdateUser - &$row,&$rowExtras
//TODO onBeforeUpdateUser make sure there are no conflicts before updating
//  onAfterUpdateUser - $row, $rowExtras, true
$_PLUGINS->registerFunction( 'onAfterUpdateUser', 'updateUser', 'jsmfCB');


class jsmfCB extends cbEventHandler
{

    function jsmfCB() {
        $this->cbEventHandler();
    }
    /**
     * Handle login event
     *
     * @access public
     * @param string $user Username
     * @param string $pass Password
     * @global object $jsmfConfig Joomla-SMF configurations
     * @return n/a
     */
    function login($user, $pass)
    {
        global $jsmfConfig;
        $jsmf =& jsmfFrontend::singleton();

    	//simply mimic our patch for joomla login
    	$_SESSION['USER_AGENT'] = $_SERVER['HTTP_USER_AGENT'];
    	$_SESSION['_FROM_MOS'] = TRUE;
        $_SESSION['_RETURN'] = mosGetParam($_REQUEST, 'return', '');
    	$jsmf->doLogin(TRUE);

    }

    /**
     * Handle logout events
     *
     *
     * @access public
     * @param object $data User information
     * @global array $context SMF context
     * @global object $jsmfConfig Joomla-SMF configurations
     * @return n/a
     */
    function logout($data)
    {
    	global $context;
        global $jsmfConfig;
        $jsmf =& jsmfFrontend::singleton();

        mosRedirect($jsmf->fixLink("index.php?action=logout&amp;sesc=".$context['session_id']));
    }

    /**
     * Activates a user in SMF
     *
     *
     * @access public
     * @param object $data User information?
     * @param boolean $activated User activation status?
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @return boolean
     */
    function activateUser($data, $activated)
    {
        global $_PLUGINS;
        global $jsmfConfig;
        //$jsmf =& jsmfFrontend::singleton();
        //Fatal error: jsmfCB::activateUser() [<a href='function.activateUser'>function.activateUser</a>]: The script tried to execute a method or access a property of an incomplete object. Please ensure that the class definition &quot;jsmfFrontend&quot; of the object you are trying to operate on was loaded _before_ unserialize() gets called or provide a __autoload() function to load the class definition in components\com_comprofiler\plugin\user\plug_smfcbplugin\smf_cb.php on line 156
        $jsmf = new jsmfFrontend();
        //make sure they are active?

        if($activated) {
            if (!$jsmf->setBlockStatus(FALSE, $data)) {
                $_PLUGINS->raiseError(0);
                $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Failed to update SMF activation status:: ".$jsmf->err);
                return false;
            }
        }
        return true;
    }

    /**
     * This function checks that the new user's email and username are not
     * already in use in SMF
     *
     * @access public
     * @param object reference $data User Information
     * @param object reference $extras User information extras
     * @param $status Registration status, default false
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @return boolean
     */
    function validateUser(&$data, &$extras, $status=FALSE)
    {
        global $_PLUGINS;
        global $jsmfConfig;

        $jsmf =& jsmfFrontend::singleton();
        $jsmfConfig = $jsmf->loadParams();

        if (!$jsmf->validateMember($data)) {
            $_PLUGINS->raiseError(0);
            $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Username or Email Address already exists in SMF");
            return false;
        }
        return true;

    }

    /**
     * Registers a user with SMF
     *
     *
     * @access public
     * @param object $data User informaiton
     * @param object $extras User information extras
     * @param boolean $status Registration status
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @return boolean
     */
    function registerUser($data, $extras, $status)
    {
        global $_PLUGINS;
        global $jsmfConfig;
        $jsmf =& jsmfFrontend::singleton();

        /*
          	id => 119
            name => test
            username => test
            email => joshualross@hotmail.com
            password => Abs0lut
            usertype => Registered
            block => 1
            sendEmail =>
            gid => 18
            registerDate => 2006-08-24T23:13:55
            lastvisitDate =>
            activation =>
            params =>
            _tbl => #__users
            _tbl_key => id
            _error =>
            _db => Object
         */
        $jsmfConfig = $jsmf->loadParams();

        if (!$jsmf->syncToSMF($data, $data->password)) {
            $_PLUGINS->raiseError(0);
            $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Failed to synchronize user to SMF:: ".$jsmf->err);
            return false;
        }
        return true;

    }

    /**
     * Deletes a user from SMF
     *
     *
     * @access public
     * @param object $data User information
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @return boolean
     */
    function deleteUser($data)
    {
        global $_PLUGINS;
        global $jsmfConfig;

        //$jsmf =& jsmfFrontend::singleton();
        //Fatal error: Unknown(): The script tried to execute a method or access a property of an incomplete object. Please ensure that the class definition jsmffrontend of the object you are trying to operate on was loaded _before_ the session was started in components/com_comprofiler/plugin/user/plug_smfcbplugin/smf_cb.php on line 258
        $jsmf = new jsmfFrontend();
        $jsmfConfig = $jsmf->loadParams();
        if (!$jsmf->deleteMember($data)) {
            $_PLUGINS->raiseError(0);
            $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Failed to delete user in SMF.\n".$jsmf->err);
            return false;
        }
        return true;

    }

    /**
     * Updates user data in SMF
     *
     *
     * @access public
     * @param object $data User information
     * @param object $extras User information extras
     * @param boolean $status Update status
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @return boolean
     */
    function updateUser($data, $extras, $status)
    {
        global $_PLUGINS;
        global $jsmfConfig;
        $jsmf = new jsmfFrontend();
        $jsmfConfig = $jsmf->loadParams();

        /*
        Row::id => 76
        Row::name => test
        Row::username => test
        Row::email => test@test.com
        Row::password =>
        Row::usertype => Registered
        Row::block => 0
        Row::sendEmail => 0
        Row::gid => 18
        Row::registerDate =>
        Row::lastvisitDate =>
        Row::activation =>
        Row::params =>
        Row::_tbl => #__users
        Row::_tbl_key => id
        Row::_error =>
        Row::_db => Object id #2
        Extras::id => 76
        Extras::user_id => 76
        Extras::avatar =>
        Extras::avatarapproved =>
        Extras::approved => 1
        Extras::confirmed => 1
        Extras::hits =>
        Extras::_tbl => #__comprofiler
        Extras::_tbl_key => id
        Extras::_error =>
        Extras::_db => Object id #2
        Extras::firstname =>
        Extras::middlename =>
        Extras::lastname =>
         */

        if (!$jsmf->updateMember($data, $extras)) {
            $_PLUGINS->raiseError(0);
            $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Failed to synchronize user updates to SMF:: ".$jsmf->err);
            return false;
        }
        return true;
    }

    /**
     * Updates user avatar in SMF
     *
     *
     * @access public
     * @param object reference $data User information
     * @param object reference $extras User information extras
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @param string $file_name Avatar filename
     * @return boolean
     */
    function updateAvatar(&$data, &$extras, $is_moderator, $file_name)
    {
        global $_PLUGINS;
        global $jsmfConfig;
        $jsmf =& jsmfFrontend::singleton();
        $jsmfConfig = $jsmf->loadParams();

        /*
        Row::id => 62
        Row::name => Administrator
        Row::username => admin
        Row::email => joshualross@gmail.com
        Row::password => 226776f356d7ecf58b60bab12a05d38f
        Row::usertype => Super Administrator
        Row::block => 0
        Row::sendEmail => 1
        Row::gid => 25
        Row::registerDate => 2006-07-14 15:43:16
        Row::lastvisitDate => 2006-08-30 15:46:14
        Row::activation =>
        Row::params => expired= expired_time=
        Row::_tbl => #__users
        Row::_tbl_key => id
        Row::_error =>
        Row::_db => Object id #2
        Row::orig_password => 226776f356d7ecf58b60bab12a05d38f
        Extras::id => 62
        Extras::user_id => 62
        Extras::avatar => gallery/airplane.gif
        Extras::avatarapproved => 1
        Extras::approved => 1
        Extras::confirmed => 1
        Extras::hits => 0
        Extras::_tbl => #__comprofiler
        Extras::_tbl_key => id
        Extras::_error =>
        Extras::_db => Object id #2
         */
        
        if (!$jsmf->updateAvatar($data, $extras, $file_name)) {
            $_PLUGINS->raiseError(0);
            $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Failed to synchronize avatar to SMF:: ".$jsmf->err);
            return false;
        }
        return true;
    }

    /**
     * Updates user password in SMF
     *
     * @access public
     * @param int $id Joomla/CB user id
     * @param string $newpass New user password
     * @global object $_PLUGINS
     * @global object $jsmfConfing Joomla-SMF configurations
     * @return boolean
     */
    function updatePass($id, $pass)
    {
    	global $_PLUGINS;
        global $jsmfConfig;
        $jsmf =& jsmfFrontend::singleton();
        $jsmfConfig = $jsmf->loadParams();

        if (!$jsmf->updatePass($id, $pass)) {
            $_PLUGINS->raiseError(0);
            $_PLUGINS->_setErrorMSG("JSMF CB Plugin error::Failed to update password to SMF:: ".$jsmf->err);
            return false;
        }
        return true;
    }
}

//        foreach($data as $key => $val) {
//            $out .= "Row::$key => $val<br />";
//        }
//        foreach ($extras as $key => $val) {
//          $out .= "Extras::$key => $val<br />";
//        }
//        die($out.'<hr/>'.$jsmf->joomlaSMF_debug());
?>